#ifndef GAME_H
#define GAME_H

#pragma warning (disable: 4312 4996)
#include <alleggl.h>
#pragma warning (default: 4312)

#include <gl/gl.h>
#include <gl/glu.h>

#include <stdlib.h>
#include <stdio.h>

#include <fmod.h>


#include "math3d.h"
#include "3d.h"
#include "map.h"

// Globals

#define MAX_TEXTURES 128
#define MAX_TILES 128
#define MAX_SOUNDS 128

extern FONT *gFont;
extern int gTextures[MAX_TEXTURES];
extern Mesh *gTiles[MAX_TILES];

extern float ringangle;

class Game
{
public:
	void Init();
	int Loop(float ticks);
};

class Camera
{
public:

	Vector pos, speed;
	float rotate, rotspeed;
	float zoom, zoomspeed;
	float angle, anglespeed;

	Camera(Vector position);

	void Update(float ticks);
	void Transform();
};

class Player
{
public:
	Mesh *playermesh;
	Vector pos, speed, rot;
	float booster;
	int score;

	float time, invincible, stuck;
	float gameover_timer;
	float ready_timer;
	int seconds_left, life;
	int laps, currow;

	float playerangle;

	// camera
	float zoom, camangle, camheight;

	Player();

	void ChaseCamera();

	void Update(float ticks);
	void Render();
	void PowerUps();

	void GameOver();
	void GameOverWait(float ticks);

	void Ready();
	void ReadyWait(float ticks);
};

#define GMODE_TITLE 0
#define GMODE_PLAYING 1
#define GMODE_GAMEOVER 2
#define GMODE_QUIT 3
#define GMODE_READY 4

extern int gGameMode;
extern Player *player;

#endif //GAME_H