#include "game.h"

int main()
{
	FSOUND_Init (44100, 32, 0);

	allegro_init();
	install_allegro_gl();

	install_keyboard();
	install_mouse();

	allegro_gl_set(AGL_COLOR_DEPTH, 16);
	allegro_gl_set(AGL_DOUBLEBUFFER, 1);
	allegro_gl_set(AGL_Z_DEPTH, 16);
	allegro_gl_set(AGL_SUGGEST, AGL_COLOR_DEPTH|AGL_DOUBLEBUFFER|AGL_Z_DEPTH);
	set_gfx_mode(GFX_OPENGL_WINDOWED, 640, 480, 0,0);
	//set_gfx_mode(GFX_OPENGL_FULLSCREEN, 1024, 768, 0,0);

	srand(time(NULL));

	Game game;
	game.Init();

	// WIN32 specific stuff
	bool qpc=false;
	__int64 freq;
	__int64 lasttick;
	int crappy_lasttick;

	if(!(qpc=QueryPerformanceFrequency((LARGE_INTEGER *) &freq)))
	{
		// fall back to crappy timer
		crappy_lasttick = GetTickCount();
	}
	else
	{
		QueryPerformanceCounter((LARGE_INTEGER *) &lasttick);
	}


	while(1)
	{
		float ticks;
		if(qpc)
		{
			__int64 tick, diff;
			QueryPerformanceCounter((LARGE_INTEGER *) &tick);
			diff = tick - lasttick;
			ticks = float(double(diff)/double(freq));
			lasttick = tick;
		}
		else
		{
			int crappy_tick = GetTickCount();
			ticks = float(crappy_tick-crappy_lasttick)/1000.f;
			crappy_lasttick = crappy_tick;
		}

		if(!game.Loop(min(ticks,.3f)))
			break;
	}

	FSOUND_Close();
	return 0;
}
END_OF_MAIN();