#ifndef MAP_H
#define MAP_H

#include "3d.h"

class Map
{
public:
	int w, h;
	float tSize;
	int *data;

	Map(char *filename);
	Map(int width, int height);
	virtual ~Map();
	void Render(Mesh **meshArray, float tileSize);

	void GetMapCoords(Vector pos, int& x, int& y);
	int& Array(int x, int y)
	{ return data[(y%h)*w+(x%w)]; }
};


#define MAX_LEVEL 4

class RandomMap : public Map
{
public:
	int size;

	RandomMap(int width, int height, int iterations);
	virtual ~RandomMap();

	void Randomize();
	void RandomRow(int row);


	/// not used in final version
	//int Neighbour(int index, int neighbour);
	//void Cycle();
	//int FindLevel(int level);

	//int FindCanGrow(int level, int growlevel);
	//int CanGrow(int index, int growlevel);
	///
};

#define MAX_ITEM 2

class ItemMap : public Map
{
public:
	RandomMap *parent;

	ItemMap(RandomMap *parentMap);
	virtual ~ItemMap();

	void Randomize();
	void RandomRow(int row);

	void Render(Mesh **meshArray, float tileSize, float tileHeight);
};


#define RING_RADIUS 950
#define TILE_SIZE 100

#endif

